// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.rawData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function field_name_set(field_name = '', callback){
    chrome.storage.local.set({field_name: field_name}, callback);
}
// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//
function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={}, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],
                '_is_request':0,
                '_shangjia_fqp_fgpf_str':_shangjia_info['_shangjia_fqp_fgpf_str'],
                '_shangjia_goodsId':'', //sku
                '_shangjia_product_url':'',
                '_shangjia_product_price':_shangjia_info['_shangjia_price'],
                '_shangjia_product_old_price':_shangjia_info['_shangjia_old_price'],
                '_shangjia_goodsName': _shangjia_info['_shangjia_name'],
                '_shangjia_minOnSalePriceStr':'',
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_category':'',
                '_shangjia_sold':_shangjia_info['_shangjia_sold'],

                '_shangjia_reivew_num':_shangjia_info['_shangjia_reivew_num'],
                '_shangjia_review_score':_shangjia_info['_shangjia_review_score'],

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_review_num':'',
                '_shangjia_store_score': ''
                //
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.temu.com/goods.html?_bg_fs=1&goods_id=601099513966458';
        if(need_item['_shangjia_about_contact_and_basic_info_link'] && need_item['_shangjia_about_contact_and_basic_info_link'].indexOf('goods.html') !=-1){
            need_item['_e_time'] = Date.now();
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
            });
            return;
        }
        console.log('request_shangjia_about_contact_and_basic_info_ajax aaa');
        console.log(need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('data');
               // console.log(data);
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(false && util_checkFanpa(_checkContent)){
                   console.log('util_checkFanpa a1');
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    pause_s_time();
                    sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
               }else{
                   //console.log('util_checkFanpa a2');
                   //
                   let scriptdata = util_getscript_pageData_content(data);
                   if(scriptdata){
                       scriptdata = scriptdata.trim();
                       scriptdata = scriptdata.replace(";document.dispatchEvent(new Event('XRenderInitialPropsLoaded'));",'')
                           .replace("window.__SSR__=1;window.__CHUNK_DATA__={};window.rawData=",'')
                        .replace("window.__CHUNK_DATA__={};window.rawData=", '');
                       console.log('scriptdata_json a1');
                       let scriptdata_json = JSON.parse(scriptdata);
                       console.log(scriptdata_json);
                       //
                       if(scriptdata_json && scriptdata_json['store']['goodsId']){
                            /*
                            '_shangjia_store_name': '',
                            '_shangjia_store_url': '',
                            '_shangjia_store_items': '',
                            '_shangjia_store_followers': '',
                            '_shangjia_store_sold': '',
                            '_shangjia_store_score': '',
                            '_shangjia_store_review_num':'',
                            //
                            '_shangjia_sold': '',
                             _shangjia_reivew_num
                            '_shangjia_goodsId':'', //sku
                            '_shangjia_variants_skus': [], //数组
                            '_shangjia_goodsName': '',
                            '_shangjia_goodsProperty':'',//description,deschtml
                            '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                            '_shangjia_gallery':[], //图片列表
                            '_shangjia_productDetailFlatList':[],//details imgs
                            '_shangjia_category':'',//brumb
                            '_shangjia_VideoUrl':'', //video
                             */
                           //
                           let _goods_data = scriptdata_json['store']['goods'];
                           if(_goods_data['status'] == 1){
                               let _shangjia_goodsId = scriptdata_json['store']['goodsId'];
                               need_item['_shangjia_goodsId'] = _shangjia_goodsId;

                               let _shangjia_goodsName = _goods_data['goodsName'];
                               need_item['_shangjia_goodsName'] = _shangjia_goodsName;
                               //
                               let review_goodsInfo = scriptdata_json['store']['reviewStore']['goodsInfo'];
                               need_item['_shangjia_product_url'] = review_goodsInfo['seoLinkUrl'];
                               need_item['_shangjia_product_price'] = review_goodsInfo['price'][1];
                               if(review_goodsInfo.hasOwnProperty('marketPriceList')){
                                   need_item['_shangjia_product_old_price'] = review_goodsInfo['marketPriceList'][1];
                               }
                               //
                               need_item['_shangjia_hdThumbUrl'] = _goods_data['hdThumbUrl'];
                               let _shangjia_minOnSalePriceStr = _goods_data['minOnSalePriceStr'];
                               need_item['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;

                               let _shangjia_category = '';
                               _shangjia_category += _dom.find('._2LmAUJYN nav ol li:eq(1)').text()+ ' > '+ _dom.find('._2LmAUJYN nav ol li:eq(2)').text();
                               need_item['_shangjia_category'] = _shangjia_category;
                               //
                               //'_shangjia_review_score': '',
                               //'_shangjia_reivew_num':'',
                               need_item['_shangjia_sold'] = _goods_data['saleInfo']['sideSalesTip'];
                               let _reviewStore_data = scriptdata_json['store']['reviewStore'];
                               need_item['_shangjia_reivew_num'] = _reviewStore_data['reviewNum'];
                               need_item['_shangjia_store_review_num'] = _reviewStore_data['mallReviewNum'];
                               //store
                               let _store_data = scriptdata_json['store']['mall']['mallData'];
                               let _shangjia_store_followers = 0;
                               if(_store_data['followerNumUnit'] && _store_data['followerNumUnit'].length>0){
                                    _shangjia_store_followers = _store_data['followerNumUnit'][0];
                               }
                               let  _shangjia_store_sold = 0;
                               if(_store_data['goodsSalesNumUnit'] && _store_data['goodsSalesNumUnit'].length >0){
                                   _shangjia_store_sold = _store_data['goodsSalesNumUnit'][0];
                               }
                               need_item['_shangjia_store_name'] = _store_data['mallName'];
                               need_item['_shangjia_store_url'] = 'https://www.temu.com'+_store_data['seoUrl'];
                               need_item['_shangjia_store_items'] = _store_data['goodsNum'];
                               need_item['_shangjia_store_followers'] = _shangjia_store_followers;
                               need_item['_shangjia_store_sold'] = _shangjia_store_sold;
                               need_item['_shangjia_store_score'] = _store_data['mallStar'];
                               //
                               need_item['_is_request'] = 2;
                           }else if(_goods_data['status'] == 5 && !_goods_data.hasOwnProperty('goodsName')){ //反爬
                               console.log('scriptdata_json This item is sold out.反爬');
                                need_item['_is_request'] = 0;
                                need_item['_error'] = '';
                                pause_s_time();
                                sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                                //
                           }else{
                               //其它类型的比如购买完了，下架了等
                               console.log('scriptdata_json 其它类型的比如购买完了，下架了等');
                               need_item['_is_request'] = 2;
                           }
                       }else{
                           console.log('scriptdata_json 未发现goods id');
                           need_item['_is_request'] = 0;
                           need_item['_error'] = '';
                           pause_s_time();
                           sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                            //
                       }
                       //
                   }else{
                       console.log('scriptdata_json error');
                       need_item['_is_request'] = 0;
                       need_item['_error'] = '';
                       pause_s_time();
                       sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }

                   /*//
                   if (need_item['_shangjia_name'] == ''){
                       let _shangjia_name = _dom.find('._2Fkk_bmp h1').text();
                       _shangjia_name = _shangjia_name.trim();
                       need_item['_shangjia_name'] = _shangjia_name;
                   }
                   //
                   let _description = _dom.find('._2tVJUTuv').text();
                   if(_description == ''){
                       _description = _dom.find('.B_OB3uj0').text();
                   }
                   need_item['_shangjia_desc'] = _description;
                   need_item['_shangjia_img'] = _dom.find('._22_BWn2A img.eIhG16Mc').attr('src');
                   //
                   //图片列表
                   let _shangjia_images_arr = [];
                   _dom.find('._2AOclWz7 ._3ACovDZO').each(function (){
                       var _img = $(this).find('img').attr('src');
                       if(_img && _img.indexOf("?") !== -1){
                           var _imgarr = _img.split('?')
                           if(_imgarr.length > 1){
                               _shangjia_images_arr.push(_imgarr[0]);
                           }
                       }
                   })
                   need_item['_shangjia_images'] = _shangjia_images_arr.join(',');
                   //
                   need_item['_shangjia_store_name'] = _dom.find('._36F9aw_t ._373TxnaS').text();
                   need_item['_shangjia_store_score'] = _dom.find('._36F9aw_t ._7JDNQb0g').attr('aria-label');
                   let _shangjia_store_url = _dom.find('._36F9aw_t a._3VEjS46S').attr('href');
                   if(_shangjia_store_url && _shangjia_store_url.indexOf('undefined') == -1){
                       need_item['_shangjia_store_url'] = 'https://www.temu.com'+_shangjia_store_url;
                   }
                   need_item['_shangjia_store_followers'] = _dom.find('._36F9aw_t ._2_doduKi ._3NlmlXKl').eq(0).text();
                   need_item['_shangjia_store_sold'] = _dom.find('._36F9aw_t ._2_doduKi ._3NlmlXKl').eq(1).text();
                   need_item['_shangjia_store_items'] = _dom.find('._36F9aw_t ._2_doduKi ._3NlmlXKl').eq(2).text();
                   //
                   need_item['_shangjia_catalog_1'] = _dom.find('.baseContent nav ol li:eq(1)').text();
                   need_item['_shangjia_catalog_2'] = _dom.find('.baseContent nav ol li:eq(2)').text();
                   //
                   if(need_item['_shangjia_store_url']){
                       need_item['_is_request'] = 2;
                   }else{
                       need_item['_is_request'] = 0;
                       need_item['_error'] = 'not found store url';
                       sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }*/
                   //
                   need_item['_e_time'] = Date.now();
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('ajax error');
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_is_request'] = 0;
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                pause_s_time();
                sendPopTips("遇到Temu反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let binfa = 0;
        for(let key in items){
             if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                 if(items[key]['_is_request'] == 1){
                     binfa++;
                     if(binfa == 5){
                         break;
                     }
                 }
             }
        }
        if(binfa < 5){
          let need_item = null;
          for(let key in items){
                if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                    if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                        need_item = items[key];
                        need_item['_is_request'] = 1;
                        need_item['_s_time'] = Date.now();
                        let obj = {};
                        obj[key] = need_item;
                        chrome.storage.local.set(obj, function (){
                            //
                            request_shangjia_about_contact_and_basic_info_ajax(key);
                            //
                        });
                        break;
                    }
                }
          }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+120000) > Date.now()){
                console.log('爬取失败，暂停120s');
             }else{
                 console.log('爬取中');
                 request_shangjia_about_contact_and_basic_info();
             }
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
//xintiao();
//setInterval(xintiao, 20000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_list') || items['pause_list'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 30000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}